﻿using System;
using System.Drawing;
using System.Linq;
using System.Windows.Forms;
using Infragistics.Win;
using Infragistics.Win.UltraWinRadialMenu;

namespace UltraRadialMenuTests
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            ultraRadialMenu1.MenuSettings.Size = new Size(this.Height - (this.Height * 40 / 100), this.Height - (this.Height * 40 / 100));
            ultraRadialMenu1.CenterButtonClick += new EventHandler<CenterButtonClickEventArgs>(ultraRadialMenu1_CenterButtonClick);
            AddTools();
        }

        void ultraRadialMenu1_CenterButtonClick(object sender, CenterButtonClickEventArgs e)
        {
            if (e.Action == CenterButtonClickAction.ToggleExpansion )
            {
                //want to hide radial menu if no child tools displayed for center tool

                // Use the Expanded property. It will be true in the case the customer is closing the Menu
                if (ultraRadialMenu1.Expanded)
                    ultraRadialMenu1.Hide();
            }
            else if (e.Action == CenterButtonClickAction.Back)
            {
                this.ultraRadialMenu1.MenuSettings.WedgeCount = this.ultraRadialMenu1.CenterTool.ParentCollection.Count;
            }


        }

        private int GetCurrentToolsCount(UIElement controlUIElement)
        {
            return 1;
        }


        private void AddTools()
        {
            //Lets say we are adding tools based on some dynamic inputs
            AddToolToCenterTool("A");
            AddToolToCenterTool("B");
            AddToolToCenterTool("C");

            RadialMenuTool toolD = AddToolToCenterTool("D");
            AddChildTools(toolD);

            AddToolToCenterTool("E");
            AddToolToCenterTool("F");
            AddToolToCenterTool("G");

            //comment these lines and check
            ultraRadialMenu1.CenterTool.WedgeSpan = 7;
            ultraRadialMenu1.MenuSettings.WedgeCount = ultraRadialMenu1.CenterTool.WedgeSpan;
        }

        private RadialMenuTool AddToolToCenterTool(string toolName)
        {
            var rmTool = new RadialMenuTool(toolName) {Text = toolName};
            ultraRadialMenu1.CenterTool.Tools.Add(rmTool);
            return rmTool;
        }

        private void AddChildTools(RadialMenuTool tool)
        {
            // Commented out the WedgeSpan calls

            var rmTool = new RadialMenuTool(tool + "1") { Text = tool + "1" };
            rmTool.Tools.Add(new RadialMenuTool(tool + "1" + ".1") { Text = tool + "1" + ".1"});
            rmTool.Tools.Add(new RadialMenuTool(tool + "1" + ".2") { Text = tool + "1" + ".2"});    
          //  rmTool.WedgeSpan = 2;
            tool.Tools.Add(rmTool);

            rmTool = new RadialMenuTool(tool + "2")  { Text = tool + "2" };
            rmTool.Tools.Add(new RadialMenuTool(tool + "2" + ".1") { Text = tool + "2" + ".1"});
            rmTool.Tools.Add(new RadialMenuTool(tool + "2" + ".2") { Text = tool + "2" + ".2"});
       //     rmTool.WedgeSpan = 2;
            tool.Tools.Add(rmTool);

            rmTool = new RadialMenuTool(tool + "3") { Text = tool + "3" };
            rmTool.Tools.Add(new RadialMenuTool(tool + "3" + ".1") { Text = tool + "3" + ".1"});
            rmTool.Tools.Add(new RadialMenuTool(tool + "3" + ".2") { Text = tool + "3" + ".2"});
         //   rmTool.WedgeSpan = 2;
            tool.Tools.Add(rmTool);

            rmTool = new RadialMenuTool(tool + "4") { Text = tool + "4" };
            rmTool.Tools.Add(new RadialMenuTool(tool + "4" + ".1") { Text = tool + "4" + ".1"});
            rmTool.Tools.Add(new RadialMenuTool(tool + "4" + ".2") { Text = tool + "4" + ".2"});
      //      rmTool.WedgeSpan = 2;
            tool.Tools.Add(rmTool);

            rmTool = new RadialMenuTool(tool + "5") { Text = tool + "1" };
            rmTool.Tools.Add(new RadialMenuTool(tool + "5" + ".1") { Text = tool + "5" + ".1"});
            rmTool.Tools.Add(new RadialMenuTool(tool + "5" + ".2") { Text = tool + "5" + ".2"});
      //      rmTool.WedgeSpan = 2;
            tool.Tools.Add(rmTool);

     //       tool.WedgeSpan = 5;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            Point pt = new Point(this.Width/2 - (ultraRadialMenu1.MenuSettings.Size.Width/2), this.Height/2 - (ultraRadialMenu1.MenuSettings.Size.Height/2));
            Point pt2 = this.PointToScreen(pt);
            ultraRadialMenu1.Show(this, pt2);
        }

        private bool AreChildToolsDisplayed(RadialMenuTool tool)
        {
            if (tool.Tools.Count == 0)
                return false;

            var visibleTools = tool.Tools.Where(t => t.Visible).ToList();

            if (visibleTools.Count == 0)
                return false;

            var element = visibleTools[0].GetUIElement();
            
            return element != null;
        }

        private void ultraRadialMenu1_DrillDownButtonClick(object sender, RadialMenuToolDrillDownButtonClickEventArgs e)
        {
            this.ultraRadialMenu1.MenuSettings.WedgeCount = e.Tool.Tools.Count;
        }

    }
}
